//
//  GSHint.h
//  GlyphsCore
//
//  Created by Georg Seifert on 21.01.09.
//  Copyright 2009 schriftgestaltung.de. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GSElement.h"
@class GSNode;

@interface GSHint : GSElement <NSCoding, NSCopying> {

	GSNode					*_originNode;
	GSNode					*_targetNode;
	NSIndexPath				*_originIndex;
	NSIndexPath				*_targetIndex;
	NSInteger				_ghost;
	NSRect					_badgeRect;
	NSPoint					_originKnob;
	NSPoint					_targetKnob;
	int						_selection;
@public
	CGFloat					_origin;
	CGFloat					_width;
	BOOL					_horizontal;
}

@property(nonatomic) CGFloat			origin;
@property(nonatomic) CGFloat			width;
@property(nonatomic) BOOL				horizontal;
@property(strong, nonatomic) GSNode		*originNode;
@property(strong, nonatomic) GSNode		*targetNode;
@property(strong, nonatomic) NSIndexPath*originIndex;
@property(strong, nonatomic) NSIndexPath*targetIndex;
@property(nonatomic) NSInteger			ghost;
@property(nonatomic) NSRect				badgeRect;
@property(nonatomic) NSPoint			originKnob;
@property(nonatomic) NSPoint			targetKnob;
@property(nonatomic) int				selection;

- (id) initWithHintDict:(NSDictionary*) HintDict;
- (void) makeGhost;
- (void) save ;
- (void) restore ;
@end
